package com.company.extendtextfielddemo.component

import com.vaadin.flow.component.Tag
import com.vaadin.flow.component.icon.VaadinIcon
import io.jmix.flowui.component.textfield.TypedTextField
import io.jmix.flowui.kit.component.button.JmixButton

@Tag("saving-text-field")
class SavingTextField : TypedTextField<String>() {

    private var originalValue: String? = null

    private val saveButton = JmixButton().apply {
        text = "Save"
        themeNames.add("tertiary-inline")
        icon = VaadinIcon.FILE.create()
    }

    init {
        saveButton.addClickListener {
            // TODO
            println("Saving value: ${value}")
        }

        addValueChangeListener { event ->
            handleOriginalValue()
            if (event.value != originalValue) enableSave() else enableSave()
        }
    }

    private fun enableSave() {
        saveButton.isEnabled = true
        errorMessage = "Not saved"
        suffixComponent = saveButton
    }

    private fun disableSave() {
        saveButton.isEnabled = false
        errorMessage = null
        suffixComponent = null
    }

    private fun handleOriginalValue() {
        if (originalValue == null) {
            originalValue = value
        }
    }
}